#include "local.h"
#include "TRomaKanaTableP.h"
#include "jstring.h"

#define	MAX_REGVALUE_SIZE		(512)
#define	MAX_REGROMAKANATABLE	(256)
#define	REGPATH_ROMAKANATABLE_A		L"Software\\TT\\Windows\\CurrentVersion\\SKKIME\\1.0\\RomaKanaTable\\A"
#define	REGPATH_ROMAKANATABLE_I		L"Software\\TT\\Windows\\CurrentVersion\\SKKIME\\1.0\\RomaKanaTable\\I"
#define	REGPATH_ROMAKANATABLE_U		L"Software\\TT\\Windows\\CurrentVersion\\SKKIME\\1.0\\RomaKanaTable\\U"
#define	REGPATH_ROMAKANATABLE_E		L"Software\\TT\\Windows\\CurrentVersion\\SKKIME\\1.0\\RomaKanaTable\\E"
#define	REGPATH_ROMAKANATABLE_O		L"Software\\TT\\Windows\\CurrentVersion\\SKKIME\\1.0\\RomaKanaTable\\O"

static	CTRomaKanaTable*	tRomaKanaTable_Create (LPCWSTR, LPCWSTR (*)[3], int) ;

/*========================================================================
 */
/* [}Ȃ̕ϊe[uuv */
LPCWSTR		_srSkkDefaultRomaKanaA [][3] = {
	{ L"",		L"",  	L"A"   },	{ L"b" ,	L"",  	L"o"   },
	{ L"by",	L"т",	L"r" },	{ L"ch",	L"",	L"`" },  
	{ L"cy",	L"",	L"`" },	{ L"d", 	L"",  	L"_"   },
	{ L"dh",	L"ł",	L"f" },	{ L"dy",	L"",	L"a" },
	{ L"f",		L"ӂ",	L"t@" },	{ L"fy",	L"ӂ",	L"t" },
	{ L"g",		L"",  	L"K"   },	{ L"gy",	L"",	L"M" },
	{ L"h",		L"",  	L"n"   },	{ L"hy",	L"Ђ",	L"q" },
	{ L"j",		L"",	L"W" },	{ L"jy",	L"",	L"W" },
	{ L"k", 	L"",  	L"J"   },	{ L"ky",	L"",	L"L" },
	{ L"m", 	L"",  	L"}"   },	{ L"my",	L"݂",	L"~" },
	{ L"n", 	L"",  	L"i"   },	{ L"ny",	L"ɂ",	L"j" },
	{ L"p", 	L"",  	L"p"   },	{ L"py",	L"҂",	L"s" },
	{ L"r", 	L"",  	L""   },	{ L"ry",	L"",	L"" },
	{ L"s", 	L"",  	L"T"   },	{ L"sh",	L"",	L"V" },
	{ L"sy",	L"",	L"V" },	{ L"t", 	L"",  	L"^"   },
	{ L"th",	L"Ă",	L"e@" },	{ L"ty",	L"",	L"`" },
	{ L"v", 	L"J",	L"@" },	{ L"w", 	L"",  	L"" },
	{ L"x", 	L"",  	L"@"   },	{ L"xk",	L"",  	L"" },
	{ L"xw",	L"",  	L""   },	{ L"xy",	L"",  	L"" },
	{ L"y", 	L"",  	L""   },	{ L"z", 	L"",  	L"U"   },
	{ L"zy",	L"",	L"W" },
} ;

/* [}Ȃ̕ϊe[uuv */
LPCWSTR		_srSkkDefaultRomaKanaI [][3] = {
	{ L"",		L"",		L"C"   },	{ L"b",		L"",		L"r"   },
	{ L"by",	L"т",	L"rB" },	{ L"ch",	L"",  	L"`"   },
	{ L"cy",	L"",	L"`B" },	{ L"d",		L"",		L"a"   },
	{ L"dh",	L"ł",	L"fB" },	{ L"dy",	L"",	L"aB" },
	{ L"f",		L"ӂ",	L"tB" },	{ L"fy",	L"ӂ",	L"tB" },
	{ L"g",		L"",		L"M"   },	{ L"gy",	L"",	L"MB" },
	{ L"h",		L"",		L"q"   },	{ L"hy",	L"Ђ",	L"qB" },
	{ L"j",		L"",		L"W"   },	{ L"jy",	L"",	L"WB" },
	{ L"k",		L"",		L"L"   },	{ L"ky",	L"",	L"LB" },
	{ L"m",		L"",		L"~"   },	{ L"my",	L"݂",	L"~B" },
	{ L"n",		L"",		L"j"   },	{ L"ny",	L"ɂ",	L"jB" },
	{ L"p",		L"",		L"s"   },	{ L"py",	L"҂",	L"sB" },
	{ L"r",		L"",		L""   },	{ L"ry",	L"股",	L"B" },
	{ L"s",		L"",		L"V"   },	{ L"sh",	L"",		L"V"   },
	{ L"sy",	L"",	L"VB" },	{ L"t",		L"",		L"`"   },
	{ L"th",	L"Ă",	L"eB" },	{ L"ty",	L"",	L"`B" },
	{ L"v",		L"J",	L"B" },	{ L"w",		L"",	L"EB" },
	{ L"x",		L"",		L"B"   },	{ L"xw",	L"",		L""   },
	{ L"z",		L"",		L"W"   },	{ L"zy",	L"",	L"WB" },
} ;

/* [}Ȃ̕ϊe[uuv */
LPCWSTR		_srSkkDefaultRomaKanaU [][3] = {
	{ L"",		L"",		L"E"   },	{ L"b",		L"",		L"u"   },
	{ L"by",	L"т",	L"r" },	{ L"ch",	L"",	L"`" },
	{ L"cy",	L"",	L"`" },	{ L"d",		L"",		L"d"   },
	{ L"dh",	L"ł",	L"f" },	{ L"dy",	L"",	L"a" },
	{ L"f",		L"",		L"t"   },	{ L"fy",	L"ӂ",	L"t" },
	{ L"g",		L"",		L"O"   },	{ L"gy",	L"",	L"M" },
	{ L"h",		L"",		L"t"   },	{ L"hy",	L"Ђ",	L"q" },
	{ L"j",		L"",	L"W" },	{ L"jy",	L"",	L"W" },
	{ L"k",		L"",		L"N"   },	{ L"ky",	L"",	L"L" },
	{ L"m",		L"",		L""   },	{ L"my",	L"݂",	L"~" },
	{ L"n",		L"",		L"k"   },	{ L"ny",	L"ɂ",	L"j" },
	{ L"p",		L"",		L"v"   },	{ L"py",	L"҂",	L"s" },
	{ L"r",		L"",		L""   },	{ L"ry",	L"",	L"" },
	{ L"s",		L"",		L"X"   },	{ L"sh",	L"",	L"V" },
	{ L"sy",	L"",	L"V" },	{ L"t",		L"",		L"c"   },
	{ L"th",	L"Ă",	L"e" },	{ L"ts",	L"",		L"c"   },
	{ L"ty",	L"",	L"`" },	{ L"v",		L"J",	L""   },
	{ L"w",		L"",		L"E"   },	{ L"x",		L"",		L"D"   },
	{ L"xt",	L"",		L"b"   },	{ L"xts",	L"",		L"b"   },
	{ L"xy",	L"",		L""   },	{ L"y",		L"",		L""   },
	{ L"z",		L"",		L"Y"   },	{ L"zy",	L"",	L"W" },
} ;

/* [}Ȃ̕ϊe[uuv */
LPCWSTR		_srSkkDefaultRomaKanaE [][3] = {
	{ L"",		L"",		L"G"   },	{ L"b",		L"",		L"x"   },
	{ L"by",	L"т",	L"rF" },	{ L"ch",	L"",	L"`F" },
	{ L"cy",	L"",	L"`F" },	{ L"d",		L"",		L"f"   },
	{ L"dh",	L"ł",	L"fF" },	{ L"dy",	L"",	L"aF" },
	{ L"f",		L"ӂ",	L"tF" },	{ L"fy",	L"ӂ",	L"tF" },
	{ L"g",		L"",		L"Q"   },	{ L"gy",	L"",	L"MF" },
	{ L"h",		L"",		L"w"   },	{ L"hy",	L"Ђ",	L"qF" },
	{ L"j",		L"",	L"WF" },	{ L"jy",	L"",	L"WF" },
	{ L"k",		L"",		L"P"   },	{ L"ky",	L"",	L"LF" },
	{ L"m",		L"",		L""   },	{ L"my",	L"݂",	L"~F" },
	{ L"n",		L"",		L"l"   },	{ L"ny",	L"ɂ",	L"jF" },
	{ L"p",		L"",		L"y"   },	{ L"py",	L"҂",	L"sF" },
	{ L"r",		L"",		L""   },	{ L"ry",	L"肥",	L"F" },
	{ L"s",		L"",		L"Z"   },	{ L"sh",	L"",	L"VF" },
	{ L"sy",	L"",	L"VF" },	{ L"t",		L"",		L"e"   },
	{ L"th",	L"Ă",	L"eF" },	{ L"ty",	L"",	L"`F" },
	{ L"v",		L"J",	L"F" },	{ L"w",		L"",	L"EF" },
	{ L"x",		L"",		L"F"   },	{ L"xk",	L"",		L""   },
	{ L"xw",	L"",		L""   },	{ L"y",		L"",	L"CF" },
	{ L"z",		L"",		L"["   },	{ L"zy",	L"",	L"WF" },
} ;

/* [}Ȃ̕ϊe[uuv */
LPCWSTR		_srSkkDefaultRomaKanaO [][3] = {
	{ L"",		L"",		L"I"   },	{ L"b",		L"",		L"{"   },
	{ L"by",	L"т",	L"r" },	{ L"ch",	L"",	L"`" },
	{ L"cy",	L"",	L"`" },	{ L"d",		L"",		L"h"   },
	{ L"dh",	L"ł",	L"f" },	{ L"dy",	L"",	L"a" },
	{ L"f",		L"ӂ",	L"tH" },	{ L"fy",	L"ӂ",	L"t" },
	{ L"g",		L"",		L"S"   },	{ L"gy",	L"",	L"M" },
	{ L"h",		L"",		L"z"   },	{ L"hy",	L"Ђ",	L"q" },
	{ L"j",		L"",	L"W" },	{ L"jy",	L"",	L"W" },
	{ L"k",		L"",		L"R"   },	{ L"ky",	L"",	L"L" },
	{ L"m",		L"",		L""   },	{ L"my",	L"݂",	L"~" },
	{ L"n",		L"",		L"m"   },	{ L"ny",	L"ɂ",	L"j" },
	{ L"p",		L"",		L"|"   },	{ L"py",	L"҂",	L"s" },
	{ L"r",		L"",		L""   },	{ L"ry",	L"",	L"" },
	{ L"s",		L"",		L"\"   },	{ L"sh",	L"",	L"V" },
	{ L"sy",	L"",	L"V" },	{ L"t",		L"",		L"g"   },
	{ L"th",	L"Ă",	L"e" },	{ L"ty",	L"",	L"`" },
	{ L"v",		L"J",	L"H" },	{ L"w",		L"",		L""   },
	{ L"x",		L"",		L"H"   },	{ L"xy",	L"",		L""   },
	{ L"y",		L"",		L""   },	{ L"z",		L"",		L"]"   },
	{ L"zy",	L"",	L"W" },
} ;

CTRomaKanaTable*
TRomaKanaTable_Create	(
	register int		nIndex)
{
	static LPCWSTR	rstrPath []	= {
		REGPATH_ROMAKANATABLE_A,	REGPATH_ROMAKANATABLE_I,
		REGPATH_ROMAKANATABLE_U,	REGPATH_ROMAKANATABLE_E,
		REGPATH_ROMAKANATABLE_O
	} ;
	static	LPCWSTR	(*rpDefaultTable []) [3]	= {
		_srSkkDefaultRomaKanaA,		_srSkkDefaultRomaKanaI,
		_srSkkDefaultRomaKanaU,		_srSkkDefaultRomaKanaE,
		_srSkkDefaultRomaKanaO
	} ;
	static	int		rnDefaultTable []	= {
		NELEMENTS (_srSkkDefaultRomaKanaA),	NELEMENTS (_srSkkDefaultRomaKanaI),
		NELEMENTS (_srSkkDefaultRomaKanaU),	NELEMENTS (_srSkkDefaultRomaKanaE),
		NELEMENTS (_srSkkDefaultRomaKanaO)
	} ;
	ASSERT (0 <= nIndex && nIndex < NUM_ROMAKANATABLEENTRY) ;

	return	tRomaKanaTable_Create (rstrPath [nIndex], rpDefaultTable [nIndex], rnDefaultTable [nIndex]) ;
}

void
TRomaKanaTable_Destroy (
	register CTRomaKanaTable*	pTable)
{
	if (pTable != NULL) 
		FREE (pTable) ;
	return ;
}

CTRomaKanaTableEntry*
TRomaKanaTable_Lookup	(
	register CTRomaKanaTable*	pTable,
	register LPCWSTR			strPrefix,
	register int				nPrefix)
{
	register CTRomaKanaTableEntry*	pEntry ;
	register int		nEntry ;
	register LPCWSTR	wstrPrefix ;

	if (pTable == NULL)
		return	NULL ;

	pEntry	= pTable->_pEntries ;
	nEntry	= pTable->_nEntries ;
	while (nEntry -- > 0) {
		wstrPrefix	= TRomaKanaTableEntry_GetPrefix (pEntry) ;
		if (wstrPrefix != NULL && 
			!lstrncmpW (wstrPrefix, strPrefix, nPrefix) &&
			*(wstrPrefix + nPrefix) == L'\0')
			return	pEntry ;
		pEntry	++ ;
	}
	return	NULL ;
}

LPCWSTR
TRomaKanaTableEntry_GetPrefix (
	const CTRomaKanaTableEntry*	pEntry)
{
	ASSERT (pEntry != NULL) ;
	return	pEntry->_wstrPrefix ;
}

LPCWSTR
TRomaKanaTableEntry_GetKatakana	(
	const CTRomaKanaTableEntry*	pEntry)
{
	ASSERT (pEntry != NULL) ;
	return	pEntry->_wstrKatakana ;
}

LPCWSTR
TRomaKanaTableEntry_GetHiragana	(
	const CTRomaKanaTableEntry*	pEntry)
{
	ASSERT (pEntry != NULL) ;
	return	pEntry->_wstrHiragana ;
}

CTRomaKanaTable*
tRomaKanaTable_Create (
	register LPCWSTR	strSubKey,
	register LPCWSTR	(*pDefaultTable) [3],
	register int		nDefaultTable)
{
	register CTRomaKanaTable*		pTable ;
	register CTRomaKanaTableEntry*	pEntry ;
	register int					nEntry ;
	register int		nIndex ;
	register int		nPrefixLen, nKanaLen, nKataLen, nLength ;
	register LPWSTR		wpPool ;
	HKEY	hSubKey ;
	WCHAR	szRegPathInfo [MAX_PATH] ;
	WCHAR	rbyData [MAX_REGVALUE_SIZE] ;
	DWORD	dwRegPathInfo, dwType, cbData ;
	LONG	lResult ;

	ASSERT (strSubKey != NULL) ;

	pTable	= NULL ;
	pEntry	= NULL ;
	nEntry	= 0 ;
#if !defined (NO_TOUCH_REGISTRY)
	if (RegOpenKeyExW (HKEY_CURRENT_USER, strSubKey, 0, KEY_READ, &hSubKey) == ERROR_SUCCESS) {
		register int	nTable ;
		
		/*	[}ϊe[uo^Ă̂ȂcB*/
		nTable	= 0 ;
		nLength	= 0 ;
		for (nIndex = 0 ; nIndex < MAX_REGROMAKANATABLE ; nIndex ++) {
			dwRegPathInfo	= NELEMENTS (szRegPathInfo) ;
			cbData			= NELEMENTS (rbyData) ;
			lResult	= RegEnumValueW (hSubKey, (DWORD)nIndex, szRegPathInfo, &dwRegPathInfo, NULL, NULL, NULL, NULL) ;
			if (lResult != ERROR_SUCCESS) 
				break ;
			
			/*	szRegPathInfo = "ky" ƂvtBNXɑB
			 *	Value = REG_MULTI_SZ ŁA, Љ̏ԁB񒷂 0 ̏ꍇɂ
			 *	``nul nul'' ɂȂċI[Ă܂...擪ꕶ]ɂB
			 *	\0Љ\0\0 ̍\AƁB
			 */
			lResult	= RegQueryValueExW (hSubKey, szRegPathInfo, NULL, &dwType, NULL, &cbData) ;
			if (lResult != ERROR_SUCCESS || dwType != REG_MULTI_SZ)
				continue ;
			
			/*	Too big value. */
			if (cbData >= sizeof (rbyData)) 
				continue ;
			cbData		= sizeof (rbyData) ;
			(void) RegQueryValueExW (hSubKey, szRegPathInfo, NULL, NULL, (BYTE*)rbyData, &cbData) ;
			
			nPrefixLen	= lstrlenW (szRegPathInfo) ;
			nKanaLen	= lstrlenW (rbyData) ;
			nKataLen	= lstrlenW (rbyData + nKanaLen + 1) ;
			/*	擪 "_" tĂBꂪȂĂƂ̂͂B*/
			if (nKanaLen < 1 || nKataLen < 1)
				continue ;
			nTable	++ ;
			nLength	+= (nPrefixLen + nKanaLen + nKataLen + 1) ;
		}
		if (nTable > 0) {
			register LPCWSTR	wstrPrefix, wstrKana, wstrKata ;
			
			pTable				= MALLOC (sizeof (CTRomaKanaTable) + nTable * sizeof (CTRomaKanaTableEntry) + nLength * sizeof (WCHAR)) ;
			pEntry				= (CTRomaKanaTableEntry*) (pTable + 1) ;
			pTable->_pEntries	= pEntry ;
			nEntry				= nTable ;
			pTable->_nEntries	= nEntry ;
			wpPool				= (LPWSTR)(pEntry + nTable) ;
			
			for (nIndex = 0 ; nIndex < nTable ; nIndex ++) {
				dwRegPathInfo	= NELEMENTS (szRegPathInfo) ;
				cbData			= NELEMENTS (rbyData) ;
				lResult	= RegEnumValueW (hSubKey, (DWORD)nIndex, szRegPathInfo, &dwRegPathInfo, NULL, NULL, NULL, NULL) ;
				if (lResult != ERROR_SUCCESS)
					break ;
				
				lResult	= RegQueryValueExW (hSubKey, szRegPathInfo, NULL, &dwType, NULL, &cbData) ;
				if (lResult != ERROR_SUCCESS || dwType != REG_MULTI_SZ)
					continue ;
				
				/*	Too big value. */
				if (cbData >= sizeof (rbyData)) 
					continue ;
				cbData		= sizeof (rbyData) ;
				(void) RegQueryValueExW (hSubKey, szRegPathInfo, NULL, NULL, (BYTE*)rbyData, &cbData) ;
				
				wstrPrefix	= szRegPathInfo ;
				wstrKana	= rbyData ;
				wstrKata	= wstrKana + lstrlenW (wstrKana) + 1 ;
				/*	擪 "_" tĂBꂪȂĂƂ̂͂B*/
				if (lstrlenW (wstrKana) < 1 || lstrlenW (wstrKata) < 1)
					continue ;
				
				pEntry [nIndex]._wstrPrefix		= wpPool ;
				lstrcpyW (wpPool, wstrPrefix) ;
				wpPool	+= lstrlenW (wstrPrefix) + 1 ;
				pEntry [nIndex]._wstrHiragana	= wpPool ;
				lstrcpyW (wpPool, wstrKana + 1) ;
				wpPool	+= lstrlenW (wstrKana) ;
				pEntry [nIndex]._wstrKatakana	= wpPool ;
				lstrcpyW (wpPool, wstrKata + 1) ;
				wpPool	+= lstrlenW (wstrKata) ;
			}
		}
		RegCloseKey (hSubKey) ;
		return	pTable ;
	}
#endif
	pTable	= MALLOC (sizeof (CTRomaKanaTable) + sizeof (CTRomaKanaTableEntry) * nDefaultTable) ;
	pTable->_pEntries	= (CTRomaKanaTableEntry *)(pTable + 1) ;
	pTable->_nEntries	= nDefaultTable ;
	pEntry	= pTable->_pEntries ;
	for (nIndex = 0 ; nIndex < nDefaultTable ; nIndex ++) {
		pEntry [nIndex]._wstrPrefix		= (*pDefaultTable)[0] ;
		pEntry [nIndex]._wstrHiragana	= (*pDefaultTable)[1] ;
		pEntry [nIndex]._wstrKatakana	= (*pDefaultTable)[2] ;
		pDefaultTable	++ ;
	}
	return	pTable ;
}

