/*
 */
#if !defined (skimcnfp_h)
#define	skimcnfp_h

#include "skimconf.h"
//#include "keymap.h"
#include "prsht.h"
//#include <commctrl.h>

#define	MAX_REGVALUE_SIZE	(sizeof (MYCHAR) * 256)

#if !defined (SIZE_MYKEYMAP)
#define	SIZE_MYKEYMAP		0x80
#endif
#if !defined (NUM_MYSPECIAL_KEY)
#define	NUM_MYSPECIAL_KEY	27
#endif

enum {
	DICTYPE_USER		= 0,
	DICTYPE_SERVER,
	DICTYPE_FILE,
	DICTYPE_SORT,
} ;

/*========================================================================
 *	Structures
 */
typedef struct {
	int				m_nWidth ;
	LPCMYSTR		m_strText ;
}	TMYLVCOLUMNDEF ;

typedef struct {
	unsigned int	m_fMask ;
	int				m_fType ;
	LPTSTR			m_strText ;
	DWORD			m_wID ;
}	TMYMENUITEM ;

typedef struct tagSkkimeConfigArg {
	TINYMEMMGR				m_MemMgr ;
	HWND					m_hPropSheetDlg ;
	HINSTANCE				m_hInst ;
	LPPROPSHEETPAGE			m_pPropSheet ;
	BYTE					m_rJMap				[SIZE_MYKEYMAP] ;
	BYTE					m_rAbbrevMap		[SIZE_MYKEYMAP] ;
	LPMYSTR					m_rInputVector		[MAX_INPUTVECTOR] ;
	LPMYSTR					m_rZenkakuVector	[MAX_INPUTVECTOR] ;
	ROMAKANATABLENODE*		m_lstRomaKanaA ;
	ROMAKANATABLENODE*		m_lstRomaKanaI ;
	ROMAKANATABLENODE*		m_lstRomaKanaU ;
	ROMAKANATABLENODE*		m_lstRomaKanaE ;
	ROMAKANATABLENODE*		m_lstRomaKanaO ;
	SKKROMAKANARULENODE*	m_lstRomaKanaRule ;
	PREFIXLISTNODE*			m_lstPrefix ;
	DICTNODE*				m_lstSearchJisyo ;
	MYCHAR					m_rszUserJisyoPath [MAX_PATH + 1] ;
	MYCOLORFACESET			m_rColorFaceSet		[MAX_SKKIME_COLORFACE] ;
	MYGENERICCONFIG			m_GenericConfig ;
#if !defined (NO_TSF)
	CICEROCONFIG			m_CiceroConfig ;
#endif
	MYCANDSELKEY			m_CandSelKey ;
}	SkkimeConfigArg ;

/*========================================================================
 *	prototypes
 */
/*	confmain.c */
BOOL				skkimeConfig_CreateKey	(LPCMYSTR, BOOL, HKEY*) ;
int					skkimeConfig_PopupMenu	(HWND, TMYMENUITEM*, int) ;
void				DebugPrintf				(LPCMYSTR,...) ;

/*	confinpv.c */
INT_PTR	CALLBACK	skkimeConfig_dlgInputVectorProc (HWND, UINT, WPARAM, LPARAM) ;
INT_PTR	CALLBACK	skkimeConfig_dlgZenkakuVectorProc(HWND, UINT, WPARAM, LPARAM) ;

/*	confkey.c */
INT_PTR	CALLBACK	skkimeConfig_dlgKeybindProc		(HWND, UINT, WPARAM, LPARAM) ;
void				skkimeConfig_key2string			(LPMYSTR, UINT) ;

/*	confrmkt.c */
INT_PTR	CALLBACK	skkimeConfig_dlgRomaKanaTblProc	(HWND, UINT, WPARAM, LPARAM) ;

/*	confrmkr.c */
INT_PTR	CALLBACK	skkimeConfig_dlgRomaKanaRuleProc(HWND, UINT, WPARAM, LPARAM) ;

/*	confdict.c */
INT_PTR	CALLBACK	skkimeConfig_dlgDictionaryProc	(HWND, UINT, WPARAM, LPARAM) ;

/*	confprfx.c */
INT_PTR	CALLBACK	skkimeConfig_dlgKanaPrefixTblProc(HWND, UINT, WPARAM, LPARAM) ;

/*	confcol.c */
INT_PTR	CALLBACK	skkimeConfig_dlgColorFaceTblProc(HWND, UINT, WPARAM, LPARAM) ;

/*	confgene.c */
INT_PTR	CALLBACK	skkimeConfig_dlgGenericProc(HWND, UINT, WPARAM, LPARAM) ;

#if !defined (NO_TSF)
/*	confcicer.c */
INT_PTR	CALLBACK	skkimeConfig_dlgCiceroProc(HWND, UINT, WPARAM, LPARAM) ;
#endif

/*	confcsel.c */
INT_PTR	CALLBACK	skkimeConfig_dlgCandidateSelectKeyProc (HWND, UINT, WPARAM, LPARAM) ;

#endif

