#if !defined (NO_TSF)
#if defined (UNIT_TEST)
#include "local.h"
#include <commctrl.h>
#include <commdlg.h>
#include <limits.h>
#include "skimcnfp.h"
#include "mystring.h"
#else
#include "windows.h"
#include "tchar.h"
#include "immdev.h"
#include "commctrl.h"
#include "commdlg.h"
#include "skki1_0.h"
#include <limits.h>
#include "conf\skimcnfp.h"
#endif
#include "resource.h"

/*	o[܂̐ݒB
 *
 */
#define	REGPATH_CICERO					MYTEXT("Software\\TT\\Windows\\CurrentVersion\\SKKIME\\1.0\\CICERO")

typedef struct {
	TINYMEMMGR*	m_pMemMgr ;
	int			m_iItem ;
	int			m_iSubItem ;
	int			m_nIndex ;
	BOOL		m_fVisible ;
	int			m_rnIndex [2] ;
}	INPLACECBCONF ;

static	BOOL	skkimeConfig_initCICERO		(LPCMYSTR, CICEROCONFIG*) ;
static	BOOL	skkimeConfig_updateCICERO	(LPCMYSTR, CICEROCONFIG*) ;

static	INT_PTR	skkimeConfig_dlgCiceroOnInitDialog	(HWND, UINT, WPARAM, LPARAM) ;
static	INT_PTR	skkimeConfig_dlgCiceroOnNotify		(HWND, UINT, WPARAM, LPARAM) ;
static	INT_PTR	skkimeConfig_dlgCiceroOnCommand		(HWND, UINT, WPARAM, LPARAM) ;

static	BOOL	dlgCicero_onNMClickLVLangBarIcon	(HWND, LPNMITEMACTIVATE, SkkimeConfigArg*, CICEROCONFIG*) ;
static	BOOL	dlgCicero_onBeginLabelEdit	(HWND, NMLVDISPINFO*, SkkimeConfigArg*, CICEROCONFIG*) ;
static	BOOL	dlgCicero_killFocusInPlaceCB(HWND, HWND, SkkimeConfigArg*, CICEROCONFIG*) ;
static	BOOL	dlgCicero_onEndLabelEdit	(HWND, NMLVDISPINFO*, SkkimeConfigArg*, CICEROCONFIG*) ;
static	BOOL	dlgCicero_defNotifyProc		(HWND, NMHDR*, SkkimeConfigArg*) ;
static	int		dlgCicero_getIndexWithItem	(HWND, int) ;

BOOL
skkimeConfig_InitializeCICERO (
	register TINYMEMMGR*	pMemMgr,
	register CICEROCONFIG*	pConfCICERO)
{
	if (pConfCICERO == NULL)
		return	FALSE ;
	return	skkimeConfig_initCICERO (REGPATH_CICERO, pConfCICERO) ;
	UNREFERENCED_PARAMETER (pMemMgr) ;
}	

BOOL
skkimeConfig_UpdateCICERO (
	register CICEROCONFIG*	pConfCICERO)
{
	if (pConfCICERO == NULL)
		return	FALSE ;

	if (skkimeConfig_updateCICERO (REGPATH_CICERO, pConfCICERO)) {
#if ! defined (CONFIG_UNIT_TEST)
		bTSF_UpdateLanguageBarIfSelected () ;	/* ... */
#endif
		return	TRUE ;
	}
	return	FALSE ;
}

INT_PTR	CALLBACK
skkimeConfig_dlgCiceroProc (
	register HWND		hDlg,
	register UINT		message,
	register WPARAM		wParam,
	register LPARAM		lParam)
{
	DEBUGPRINTFEX (99, (MYTEXT ("skkimeConfig_dlgCiceroProc (%d, %x, %x)\n"),
						message, wParam, lParam)) ;

	switch (message) {
	case	WM_INITDIALOG:
		return	skkimeConfig_dlgCiceroOnInitDialog (hDlg, message, wParam, lParam) ;

	case	WM_NOTIFY:
		return	skkimeConfig_dlgCiceroOnNotify (hDlg, message, wParam, lParam) ;

	case	WM_COMMAND:
		return	skkimeConfig_dlgCiceroOnCommand (hDlg, message, wParam, lParam) ;

	default:
		break ;
	}
	return	FALSE ;
}

/*========================================================================*
 */
INT_PTR
skkimeConfig_dlgCiceroOnInitDialog (
	register HWND		hDlg,
	register UINT		message,
	register WPARAM		wParam,
	register LPARAM		lParam)
{
	register HWND				hdlgList ;
	register LPPROPSHEETPAGE	pPropSheet ;
	register SkkimeConfigArg*	pConfArg ;
	register CICEROCONFIG*		pConfCicero ;
	static struct {
		LPMYSTR	m_strTitle ;
		int		m_nWidth ;
	}	srColumnInfo []	= {
		{ MYTEXT ("ACR"),		130, },
		{ MYTEXT ("\ݒ"),		100, },
	} ;
	static LPMYSTR				srstrItem [] = {
		MYTEXT ("L[{[h"),
		MYTEXT ("͕"),
		MYTEXT ("̓[h"),
	} ;

	DEBUGPRINTFEX (100, (TEXT ("skkimeConfig_dlgCiceroOnInitDialog (%x, %d, %x, %x)\n"),
						 hDlg, message, wParam, lParam)) ;

	SetWindowLongPtr (hDlg, DWLP_USER, (LONG_PTR) lParam) ;
	pPropSheet	= (LPPROPSHEETPAGE) lParam ;
	pConfArg	= (SkkimeConfigArg *) pPropSheet->lParam ;
	pConfCicero	= &pConfArg->m_CiceroConfig ;

	hdlgList	= GetDlgItem (hDlg, IDC_LIST_LANGBARICON) ;
	if (hdlgList != NULL) {
		register int		nIndex, i, nItem ;
		MYLV_COLUMN			lvColumn;
		MYLVITEM			lvI ;
		register DLGPROC	pOrigDlgProc ;

		MyListView_DeleteAllItems (hdlgList) ;

		lvColumn.mask	= LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM ;
		lvColumn.fmt	= LVCFMT_LEFT ;
		
		// Insert the columns in the list view.
		for (nIndex = 0; nIndex < ARRAYSIZE (srColumnInfo) ; nIndex ++) {
			lvColumn.cx			= srColumnInfo [nIndex].m_nWidth ;
			lvColumn.pszText	= srColumnInfo [nIndex].m_strTitle ;
			MyListView_InsertColumn (hdlgList, nIndex, &lvColumn) ;
		}
		
		lvI.mask		= LVIF_TEXT | LVIF_PARAM | LVIF_STATE ;
		lvI.state		= 0 ; 
		lvI.stateMask	= 0 ;
		//nItem			= 0 ;
		
		// Initialize MYLVITEM members that are different for each item. 
		nIndex	= 0 ;
		for (i = 0 ; i < NUM_SHOWKEYICON ; i ++) {
			lvI.iItem		= nIndex ;
			lvI.iImage		= 0 ;
			lvI.iSubItem	= 0 ;
			lvI.lParam		= (LPARAM) nIndex ;
			lvI.pszText		= srstrItem [i] ;
			nItem			= MyListView_InsertItem (hdlgList, &lvI) ;
			if (nItem != -1) {
				MyListView_SetItemText (hdlgList, nItem, 1, pConfCicero->m_rfShowLangBarIcon [i]? MYTEXT ("\") : MYTEXT ("\")) ;
				nIndex	++ ;
			}
		}
	}
	pConfCicero->m_hwndEdit			= NULL ;
	pConfCicero->m_nEditingItem		= -1 ;
	pConfCicero->m_nEditingSubItem	= -1 ;
	pConfCicero->m_nEditTrue		= -1 ;
	return	FALSE ;

	UNREFERENCED_PARAMETER (message) ;
	UNREFERENCED_PARAMETER (wParam) ;
}

INT_PTR
skkimeConfig_dlgCiceroOnNotify (
	register HWND		hDlg,
	register UINT		message,
	register WPARAM		wParam,
	register LPARAM		lParam)
{
	register LPPROPSHEETPAGE	pPropSheet ;
	register SkkimeConfigArg*	pConfArg ;
	register CICEROCONFIG*		pConfCicero ;
	register NMHDR	FAR*		pNMHDR	= (NMHDR *) lParam ;

	pPropSheet	= (LPPROPSHEETPAGE) GetWindowLongPtr (hDlg, DWLP_USER) ;
	pConfArg	= (SkkimeConfigArg *)  pPropSheet->lParam ; 
	pConfCicero	= &pConfArg->m_CiceroConfig ;

	switch (pNMHDR->idFrom) {
	case	IDC_LIST_LANGBARICON:
		switch (pNMHDR->code) {
		case	NM_CLICK:
			return	dlgCicero_onNMClickLVLangBarIcon (hDlg, (LPNMITEMACTIVATE) lParam, pConfArg, pConfCicero) ;
		
		case	LVN_BEGINLABELEDIT:
			return	!dlgCicero_onBeginLabelEdit (hDlg, (NMLVDISPINFO*) lParam, pConfArg, pConfCicero) ; 
		case	LVN_ENDLABELEDIT:
			dlgCicero_onEndLabelEdit (hDlg, (NMLVDISPINFO*) lParam, pConfArg, pConfCicero) ;

		case	NM_CUSTOMDRAW:
		{
			register LPNMLVCUSTOMDRAW	lpLVCD	= (LPNMLVCUSTOMDRAW) lParam ;
			register LRESULT			lRetval	= 0 ;

			switch (lpLVCD->nmcd.dwDrawStage) {
			case	CDDS_PREPAINT:
				lRetval		= CDRF_NOTIFYITEMDRAW ;
				break ;
			case	CDDS_ITEMPREPAINT:
				lRetval		= CDRF_NOTIFYSUBITEMDRAW ;
				break ;
			case	CDDS_ITEMPREPAINT | CDDS_SUBITEM:
			{
			    register int		nItem		= lpLVCD->nmcd.dwItemSpec ;
				register int		nSubItem	= lpLVCD->iSubItem ;
				//register HWND		hwnd		= pNMHDR->hwndFrom ;
				//register HDC		hDC			= lpLVCD->nmcd.hdc ;

				if (pConfCicero->m_hwndEdit != NULL &&
					pConfCicero->m_nEditingItem == nItem &&
					pConfCicero->m_nEditingSubItem == nSubItem) {
					lRetval		= CDRF_SKIPDEFAULT ;
				} else {
					lRetval		= CDRF_NOTIFYSUBITEMDRAW ;
				}
				break ;
			}
			default:
				lRetval		= CDRF_DODEFAULT ;
				break ;
			}
			SetWindowLongPtr (hDlg, DWLP_MSGRESULT, lRetval) ;
			return	TRUE ;
		}
		default:
			break ;
		}
		return	TRUE;
	default:
		return	dlgCicero_defNotifyProc (hDlg, pNMHDR, pConfArg) ;
	}

	UNREFERENCED_PARAMETER (message) ;
	UNREFERENCED_PARAMETER (wParam) ;
}

INT_PTR
skkimeConfig_dlgCiceroOnCommand (
	register HWND		hDlg,
	register UINT		message,
	register WPARAM		wParam,
	register LPARAM		lParam)
{
	register LPPROPSHEETPAGE	pPropSheet ;
	register SkkimeConfigArg*	pConfArg ;
	register CICEROCONFIG*		pConfCicero ;
	register WORD	wNotifyCode ;
	register WORD	wID ;
	register HWND	hwndCtl ;

	wNotifyCode	= HIWORD (wParam) ;
	wID			= LOWORD (wParam) ;
	hwndCtl		= (HWND) lParam ;

	DEBUGPRINTFEX (99, (MYTEXT ("HWND:(%lx), ID(%u), Notify(%u), CTLWND:(%lx)\n"),
						hDlg, wID, wNotifyCode, hwndCtl)) ;
	
	pPropSheet	= (LPPROPSHEETPAGE) GetWindowLongPtr (hDlg, DWLP_USER) ;
	pConfArg	= (SkkimeConfigArg *)  pPropSheet->lParam ; 
	pConfCicero	= &pConfArg->m_CiceroConfig ;

	if (wID == IDC_LIST_LANGBARICON) {
		register HWND	hwndLV	= GetDlgItem (hDlg, IDC_LIST_LANGBARICON) ;

		if (hwndLV == NULL)
			return	1 ;
	} else if (pConfCicero->m_hwndEdit != NULL &&
			   hwndCtl == pConfCicero->m_hwndEdit) {
		switch (wNotifyCode) {
		case	CBN_SELCHANGE:
		{
			register int	nCurSel, nItem, nIndex ;
			register BOOL	fVisible ;
			register HWND	hwndLV ;

			hwndLV		= GetDlgItem (hDlg, IDC_LIST_LANGBARICON) ;
			nCurSel		= SendMessage (hwndCtl, CB_GETCURSEL, 0, 0) ;
			fVisible	= (nCurSel == pConfCicero->m_nEditTrue) ;
			nItem		= pConfCicero->m_nEditingItem ;
			nIndex		= dlgCicero_getIndexWithItem (hwndLV, nItem) ;
			if (0 <= nIndex && nIndex < NUM_SHOWKEYICON &&
				fVisible != pConfCicero->m_rfShowLangBarIcon [nIndex]) {
				pConfCicero->m_rfShowLangBarIcon [nIndex]	= fVisible ;
				PropSheet_Changed (pConfArg->m_hPropSheetDlg, hDlg) ;
			}
			break ;
		}
		case	CBN_KILLFOCUS:
		case	CBN_SELENDOK:
		case	CBN_SELENDCANCEL:
			break ;
		}
	}

	return 0 ;

	UNREFERENCED_PARAMETER (message) ;
}

/*========================================================================*
 */

BOOL
skkimeConfig_initCICERO (
	register LPCMYSTR		strSubKey,
	register CICEROCONFIG*	pConfCICERO)
{
	HKEY			hSubKey ;
	static LPCMYSTR	rstrKEY [NUM_SHOWKEYICON]	= {
		MYTEXT (REGKEY_SHOWKEYBRDICON),
		MYTEXT (REGKEY_SHOWIMEICON),
		MYTEXT (REGKEY_SHOWINPUTMODEICON)
	} ;
	BOOL			rfShow [NUM_SHOWKEYICON] = { TRUE, TRUE, TRUE } ;
	register int	i ;

	if (MyRegOpenKeyEx (HKEY_CURRENT_USER, strSubKey, 0, KEY_READ, &hSubKey) == ERROR_SUCCESS) {
		DWORD			dwValue, cbData, dwType ;

		for (i = 0 ; i < ARRAYSIZE (rstrKEY) ; i ++) {
			cbData	= sizeof (DWORD) ;
			dwValue	= 0 ;
			if (MyRegQueryValueEx (hSubKey, rstrKEY [i], NULL, &dwType, (LPBYTE) &dwValue, &cbData) == ERROR_SUCCESS &&
				dwType == REG_DWORD) 
				rfShow [i]	= (dwValue != 0) ;
		}
		MyRegCloseKey (hSubKey) ;
	}
	for (i = 0 ; i < NUM_SHOWKEYICON ; i ++)
		pConfCICERO->m_rfShowLangBarIcon [i]	= rfShow [i] ;
	return	TRUE ;
}

BOOL
skkimeConfig_updateCICERO (
	register LPCMYSTR		strSubKey,
	register CICEROCONFIG*	pConfCICERO)
{
	static LPCMYSTR	rstrKEY [NUM_SHOWKEYICON]	= {
		MYTEXT (REGKEY_SHOWKEYBRDICON),
		MYTEXT (REGKEY_SHOWIMEICON),
		MYTEXT (REGKEY_SHOWINPUTMODEICON)
	} ;
	HKEY			hSubKey ;
	DWORD			dwShow ;
	register BOOL	fRetval	= TRUE ;
	register int	i ;

	if (! skkimeConfig_CreateKey (strSubKey, FALSE, &hSubKey))
		return	FALSE ;
	
	for (i = 0 ; i < ARRAYSIZE (rstrKEY) ; i ++) {
		dwShow	= pConfCICERO->m_rfShowLangBarIcon [i] ;
		if (MyRegSetValueEx (hSubKey, rstrKEY [i], 0, REG_DWORD, (LPBYTE) &dwShow, sizeof (DWORD)) != ERROR_SUCCESS) {
			fRetval	= FALSE ;
			break ;
		}
	}
	if (RegCloseKey (hSubKey) != ERROR_SUCCESS)
		fRetval	= FALSE ;
	return	fRetval ;
}

BOOL
dlgCicero_onNMClickLVLangBarIcon (
	register HWND				hDlg,
	register LPNMITEMACTIVATE	pNMIA,
	register SkkimeConfigArg*	pConfArg,
	register CICEROCONFIG*		pConfCicero)
{
	register HWND				hwndLV ;
	register int				nIndex, nSubItem, nItem ;
	LVITEM						lvI ;
	LVHITTESTINFO				lvHIT ;

	hwndLV	= GetDlgItem (hDlg, IDC_LIST_LANGBARICON) ;

	lvHIT.pt		= pNMIA->ptAction ;
	lvHIT.flags		= LVHT_ONITEMLABEL ;
	lvHIT.iItem		= 0 ;
	lvHIT.iSubItem	= 0 ;
	if (ListView_SubItemHitTest (hwndLV, &lvHIT) < 0)
		return	TRUE ;
	nItem			= lvHIT.iItem ;
	nSubItem		= lvHIT.iSubItem ;

	if (nItem == pConfCicero->m_nEditingItem &&
		nSubItem == pConfCicero->m_nEditingSubItem) {
		WPARAM		wParam	= MK_LBUTTON ;
		LPARAM		lParam	= MAKELPARAM (pNMIA->ptAction.x, pNMIA->ptAction.y) ;

		DEBUGPRINTFEX (99, (MYTEXT ("forward NM_CLICK\n"))) ;
		SendMessage (pConfCicero->m_hwndEdit, WM_LBUTTONDOWN, wParam, lParam) ;
		return	TRUE ;
	}

	/*	ʂ̏ꏊNbNꂽ Kill B*/
	if (pConfCicero->m_hwndEdit != NULL) {
		dlgCicero_killFocusInPlaceCB (hDlg, pConfCicero->m_hwndEdit, pConfArg, pConfCicero) ;
	}

	memset (&lvI, 0, sizeof (lvI)) ;
	lvI.mask		= LVIF_PARAM ;		
	lvI.iItem		= nItem ;
	lvI.iSubItem	= 0 ;
	if (! ListView_GetItem (hwndLV, &lvI))
		return	TRUE ;
	nIndex			= lvI.lParam ;
	
	/*	 Subitem IꂽH */
	if (nItem >= 0 && nSubItem > 0 &&
		0 <= nIndex && nIndex < NUM_SHOWKEYICON) {
		NMLVDISPINFO		di ;
		
		ListView_SetItemState (hwndLV, nItem, 0, LVIS_CUT | LVIS_DROPHILITED | LVIS_SELECTED | LVIS_FOCUSED) ;

		di.hdr.hwndFrom		= hwndLV ;
		di.hdr.idFrom		= GetDlgCtrlID (hwndLV) ;
		di.hdr.code			= LVN_BEGINLABELEDIT ;
		
		di.item.mask		= LVIF_TEXT ;
		di.item.iItem		= nItem ;
		di.item.iSubItem	= nSubItem ;
		di.item.pszText		= pConfCicero->m_rfShowLangBarIcon [nIndex]? TEXT ("\") : TEXT ("\") ;
		di.item.cchTextMax	= lstrlen ((LPCTSTR)di.item.pszText) ;
		
		SendMessage (hDlg, WM_NOTIFY, LVN_BEGINLABELEDIT, (LPARAM) &di) ;
	}
	return	TRUE ;	/* NM_CLICK ̕Ԃl͖B*/
}

BOOL
dlgCicero_onBeginLabelEdit (
	register HWND				hDlg,
	register NMLVDISPINFO*		pdi,
	register SkkimeConfigArg*	pConfArg,
	register CICEROCONFIG*		pConfCicero)
{
	register HWND	hwndEdit, hwndLV ;
	RECT			rc ;
	register int	nItem, nIndex, x, y, width, height ;
	register BOOL	fVisible ;
	int				rCBItem [2] ;
	POINT			pt ;
	register HFONT	hFont ;

	DEBUGPRINTFEX (99, (MYTEXT ("LVN_BEGINLABELEDIT (1)\n"))) ;
	
	if (pConfCicero->m_hwndEdit != NULL)
		return	FALSE ;

	hwndLV	= GetDlgItem (hDlg, IDC_LIST_LANGBARICON) ;
	if (hwndLV == NULL)
		return	FALSE ;

	hFont		= (HFONT) SendMessage (hwndLV, WM_GETFONT, 0, 0) ;
	nIndex		= dlgCicero_getIndexWithItem (hwndLV, pdi->item.iItem) ;
	if (nIndex < 0)
		return	FALSE ;

	/*	COMBOBOX ̍쐬ƏB
	 */
	/*	COMBOBOX ̈ʒuB
	 */
	ListView_GetSubItemRect (hwndLV, pdi->item.iItem, pdi->item.iSubItem, LVIR_BOUNDS, &rc) ;
	//SendMessage (hwndEdit, CB_SETITEMHEIGHT, (WPARAM) -1, (LPARAM) (rc.bottom - rc.top) * 2) ;
	//SendMessage (hwndEdit, CB_SETDROPPEDWIDTH, (WPARAM) (rc.bottom - rc.top) * 2, 0) ;
	pt.x	= rc.left ;
	pt.y	= rc.top ;
	ClientToScreen (hwndLV, &pt) ;
	ScreenToClient (hDlg, &pt) ;
	x		= pt.x ;
	y		= pt.y - 4 ;
	width	= rc.right - rc.left ;
	height	= (rc.bottom - rc.top) * 4 ;
	hwndEdit	= CreateWindow (TEXT ("COMBOBOX"), TEXT ("LocInPlaceEdit"), WS_BORDER | WS_CHILD | WS_VISIBLE | CBS_DROPDOWNLIST, x, y, width, height, hDlg, NULL, pConfArg->m_hInst, NULL) ;
	if (hwndEdit == NULL) 
		return	FALSE ;

	fVisible	= pConfCicero->m_rfShowLangBarIcon [nIndex] ;
	rCBItem [1]	= (int) SendMessage (hwndEdit, CB_ADDSTRING, 0, (LPARAM) TEXT ("\")) ;
	rCBItem [0]	= (int) SendMessage (hwndEdit, CB_ADDSTRING, 0, (LPARAM) TEXT ("\")) ;
	SendMessage (hwndEdit, CB_SETCURSEL, rCBItem [fVisible != FALSE], 0) ;
	SendMessage (hwndEdit, WM_SETFONT, (WPARAM) hFont, 0) ;

	DEBUGPRINTFEX (99, (MYTEXT ("hwndEdit: visible(%d), cursel(%d), index(%d), item(%d)\n"),
						fVisible, rCBItem [fVisible != FALSE], nIndex, 
						pdi->item.iItem)) ;

	SetWindowPos (hwndEdit, HWND_TOP, 0, 0, 0, 0, SWP_NOSIZE | SWP_NOMOVE) ;
	SetFocus (hwndEdit) ;

	pConfCicero->m_hwndEdit			= hwndEdit ;
	pConfCicero->m_nEditingItem		= pdi->item.iItem ;
	pConfCicero->m_nEditingSubItem	= pdi->item.iSubItem ;
	pConfCicero->m_nEditTrue		= rCBItem [1] ;
	return	TRUE ;
}

BOOL
dlgCicero_killFocusInPlaceCB (
	register HWND				hDlg,
	register HWND				hwndCtrl,
	register SkkimeConfigArg*	pConfArg,
	register CICEROCONFIG*		pConfCicero)
{
	register HWND		hwndLV ;
	NMLVDISPINFO		di ;
	register int		nCurSel ;
	register BOOL		fVisible ;
		
	nCurSel				= SendMessage (hwndCtrl, CB_GETCURSEL, 0, 0) ;
	fVisible			= (nCurSel == pConfCicero->m_nEditTrue) ;

	hwndLV				= GetDlgItem (hDlg, IDC_LIST_LANGBARICON) ;
	di.hdr.hwndFrom		= hwndLV ;
	di.hdr.idFrom		= GetDlgCtrlID (hwndLV) ;
	di.hdr.code			= LVN_ENDLABELEDIT ;
	
	di.item.mask		= LVIF_TEXT ;
	di.item.iItem		= pConfCicero->m_nEditingItem ;
	di.item.iSubItem	= pConfCicero->m_nEditingSubItem ;
	di.item.pszText		= fVisible? TEXT ("\") : TEXT ("\") ;
	di.item.cchTextMax	= lstrlen ((LPCTSTR)di.item.pszText) ;
	SendMessage (hDlg, WM_NOTIFY, LVN_ENDLABELEDIT, (LPARAM) &di) ;
	return	TRUE ;
}

BOOL
dlgCicero_onEndLabelEdit (
	register HWND				hDlg,
	register NMLVDISPINFO*		pdi,
	register SkkimeConfigArg*	pConfArg,
	register CICEROCONFIG*		pConfCicero)
{
	register int			iItem		= pdi->item.iItem ;
	register int			iSubItem	= pdi->item.iSubItem ;
	LVITEM					lvI ;
	register HWND			hwndLV ;
	register int			nIndex ;
	
	if (! pConfCicero->m_hwndEdit)
		return	FALSE ;
	
	hwndLV	= GetDlgItem (hDlg, IDC_LIST_LANGBARICON) ;
	if (hwndLV == NULL)
		goto	skip ;

	if (pdi->item.pszText) {
		nIndex	= dlgCicero_getIndexWithItem (hwndLV, iItem) ;
		if (nIndex < 0 || nIndex >= NUM_SHOWKEYICON)
			goto	skip ;
		if (! lstrcmp (pdi->item.pszText, TEXT ("\"))) {
			ListView_SetItemText (hwndLV, iItem, iSubItem, TEXT ("\")) ;
			pConfCicero->m_rfShowLangBarIcon [nIndex]	= TRUE ;
		} else {
			ListView_SetItemText (hwndLV, iItem, iSubItem, TEXT ("\")) ;
			pConfCicero->m_rfShowLangBarIcon [nIndex]	= FALSE ;
		}
		PropSheet_Changed (pConfArg->m_hPropSheetDlg, hDlg) ;
	}
  skip:
	DestroyWindow (pConfCicero->m_hwndEdit) ;
	pConfCicero->m_hwndEdit			= NULL ;
	pConfCicero->m_nEditingItem		= -1 ;
	pConfCicero->m_nEditingSubItem	= -1 ;
	pConfCicero->m_nEditTrue		= -1 ;
	return	TRUE ;
}

BOOL
dlgCicero_defNotifyProc (
	register HWND				hDlg,
	register NMHDR*				pNMHDR,
	register SkkimeConfigArg*	pConfArg)
{
	switch (pNMHDR->code){
	case PSN_SETACTIVE:
		SetWindowLongPtr (hDlg, DWLP_MSGRESULT, 0) ;
		return	TRUE ;
		
	case PSN_KILLACTIVE:
		SetWindowLongPtr (hDlg, DWLP_MSGRESULT, FALSE) ;
		return	TRUE ;
		
	case PSN_APPLY:
	{
		if (skkimeConfig_UpdateCICERO (&pConfArg->m_CiceroConfig)) {
			SetWindowLongPtr (hDlg, DWLP_MSGRESULT, PSNRET_NOERROR) ;
		} else {
			SetWindowLongPtr (hDlg, DWLP_MSGRESULT, PSNRET_INVALID) ;
		}
		return	TRUE ;
	}
	case PSN_RESET:
	case PSN_HELP:
		break ;
	default:
		return FALSE ;
	}
	return	TRUE ;
}

int
dlgCicero_getIndexWithItem (
	register HWND				hwndLV,
	register int				nItem)
{
	LVITEM		lvI ;

	memset (&lvI, 0, sizeof (lvI)) ;
	lvI.mask	= LVIF_PARAM ;
	lvI.iItem	= nItem ;
	if (! ListView_GetItem (hwndLV, &lvI))
		return	-1 ;
	return	(int) lvI.lParam ;
}

#endif
